Description

Yesterday I had to monkey-patch "Group" in a plugin, and it turned out to be really difficult because there's a scope defined in the

Group class which doesn't use lambda. In this case, the scope is evaluated directly, which fails with "Could not find table users" for

instance if you're in a "db:migrate" phase and your database is empty.

Hence I propose moving all scopes to their lambda form so that these difficulties disappear for plugin development.

One more thing, using scopes without lambda (or a call-able) will be deprecated in Rails 4 and probably removed in Rails 4.1 (see 

this commit).

Let me know what you think. If you're OK with this change I can take care of verifying all models, running tests and making the

change everywhere...

Associated revisions

Revision 10949 - 2012-12-07 11:12 - Jean-Baptiste Barth

Use lambda form in model scopes (#12499)

Revision 12486 - 2014-01-07 08:51 - Toshi MARUYAMA

use lambda form in Version model scope (#12499)

Revision 12487 - 2014-01-07 11:02 - Toshi MARUYAMA

use lambda form in acts_as_tree scope (#12499)

History

#1 - 2012-12-04 10:30 - Jean-Baptiste Barth

If you want to see what's involved, here are the two commits on my plugin : one, two (but please don't start me on the bad idea of monkey patching

core classes, that's all I have now to accomplish this kind of change...)

#2 - 2012-12-04 17:08 - Etienne Massip

Looks ok to me, should be marked as a deprecated usage in RoR, too bad it is not?

#3 - 2012-12-04 20:30 - Jean-Philippe Lang

- Target version set to 2.3.0

Agreed.

#4 - 2012-12-07 11:25 - Jean-Baptiste Barth

- Status changed from New to Resolved

Done in r10949. I left scopes in the same form they used before (some use Arel syntax, some use the rails 2 hash syntax) but I might dig into that

later.

#5 - 2012-12-08 09:55 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Jean-Baptiste Barth wrote:
https://github.com/rails/rails/commit/0a12a5f8169685915cbb7bf4d0a7bb482f7f2fd2
https://github.com/jbbarth/redmine_organizations/commit/64a3bd7f1559354a11d7231a850a6cedab1742af
https://github.com/jbbarth/redmine_organizations/commit/a7d19ed4e09df6c96ecb317593c0a97a650d3bec
https://www.redmine.org/projects/redmine/repository/svn/revisions/10949


Done in r10949. I left scopes in the same form they used before (some use Arel syntax, some use the rails 2 hash syntax) but I might dig into

that later.

 Thanks, scopes now use Arel BTW (r10950).
